package framework.everywaretechnologies.it.icarus;

import android.content.SharedPreferences;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class UserSettingsResource extends IcarusResource { //classe da non serializzare direttamente con Gson, ma pensata per essere compilata dall'app chiamante

    private Map<String,String> prefsOldNew; //il secondo String è in realtà un JSONObject convertito in String
    private SharedPreferences callerSharedPrefs;

    public UserSettingsResource(SharedPreferences _callerSharedPrefs){

        super();

        prefsOldNew=new HashMap<>();
        callerSharedPrefs=_callerSharedPrefs; //così posso modificare le SharedPreferences dell'app chiamante
    }

    //a seconda del tipo di preferenza il chiamante invocherà uno di questi metodi

    public void addBoolean(String prefName, boolean newValue ) {

        JSONObject jsonObject=new JSONObject();
        try {

            if (callerSharedPrefs.contains(prefName + "_old")) { //se ho già toccato quella pref in passato

                boolean oldValue=callerSharedPrefs.getBoolean(prefName+"_old",false);

                if(oldValue!=newValue){

                    jsonObject.put("old", oldValue);
                    jsonObject.put("new",newValue);
                    prefsOldNew.put(prefName,jsonObject.toString());

                    //update shared preferences dell'app chiamante
                    SharedPreferences.Editor editor=callerSharedPrefs.edit();
                    editor.putBoolean(prefName+"_old",newValue);
                    editor.apply(); //apply aggiorna le prefs in bg
                }

            } else { //se è la prima volta che l'utente tocca quella pref

                jsonObject.put("old", null);
                jsonObject.put("new",newValue);
                prefsOldNew.put(prefName,jsonObject.toString());

                //update shared preferences dell'app chiamante
                SharedPreferences.Editor editor=callerSharedPrefs.edit();
                editor.putBoolean(prefName+"_old",newValue);
                editor.apply(); //apply aggiorna le prefs in bg
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public void addInt(String prefName, int newValue ){

        JSONObject jsonObject=new JSONObject();
        try {

            if (callerSharedPrefs.contains(prefName + "_old")) {

                int oldValue=callerSharedPrefs.getInt(prefName+"_old",-1);

                if(oldValue!=newValue){

                    jsonObject.put("old", oldValue);
                    jsonObject.put("new",newValue);
                    prefsOldNew.put(prefName,jsonObject.toString());

                    //update shared preferences dell'app chiamante
                    SharedPreferences.Editor editor=callerSharedPrefs.edit();
                    editor.putInt(prefName+"_old",newValue);
                    editor.apply(); //apply aggiorna le prefs in bg
                }

            } else { //se è la prima volta che l'utente tocca quella pref

                jsonObject.put("old", null);
                jsonObject.put("new",newValue);
                prefsOldNew.put(prefName,jsonObject.toString());

                //update shared preferences dell'app chiamante
                SharedPreferences.Editor editor=callerSharedPrefs.edit();
                editor.putInt(prefName+"_old",newValue);
                editor.apply(); //apply aggiorna le prefs in bg
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public void addFloat(String prefName, float newValue ){

        JSONObject jsonObject=new JSONObject();
        try {

            if (callerSharedPrefs.contains(prefName + "_old")) {

                float oldValue=callerSharedPrefs.getFloat(prefName+"_old",-1);

                if(oldValue!=newValue){

                    jsonObject.put("old", oldValue);
                    jsonObject.put("new",newValue);
                    prefsOldNew.put(prefName,jsonObject.toString());

                    //update shared preferences dell'app chiamante
                    SharedPreferences.Editor editor=callerSharedPrefs.edit();
                    editor.putFloat(prefName+"_old",newValue);
                    editor.apply(); //apply aggiorna le prefs in bg
                }

            } else { //se è la prima volta che l'utente tocca quella pref

                jsonObject.put("old", null);
                jsonObject.put("new",newValue);
                prefsOldNew.put(prefName,jsonObject.toString());

                //update shared preferences dell'app chiamante
                SharedPreferences.Editor editor=callerSharedPrefs.edit();
                editor.putFloat(prefName+"_old",newValue);
                editor.apply(); //apply aggiorna le prefs in bg
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public void addLong(String prefName, long newValue ){

        JSONObject jsonObject=new JSONObject();
        try {

            if (callerSharedPrefs.contains(prefName + "_old")) {

                long oldValue=callerSharedPrefs.getLong(prefName+"_old",-1);

                if(oldValue!=newValue){

                    jsonObject.put("old", oldValue);
                    jsonObject.put("new",newValue);
                    prefsOldNew.put(prefName,jsonObject.toString());

                    //update shared preferences dell'app chiamante
                    SharedPreferences.Editor editor=callerSharedPrefs.edit();
                    editor.putFloat(prefName+"_old",newValue);
                    editor.apply(); //apply aggiorna le prefs in bg
                }

            } else { //se è la prima volta che l'utente tocca quella pref

                jsonObject.put("old", null);
                jsonObject.put("new",newValue);
                prefsOldNew.put(prefName,jsonObject.toString());

                //update shared preferences dell'app chiamante
                SharedPreferences.Editor editor=callerSharedPrefs.edit();
                editor.putFloat(prefName+"_old",newValue);
                editor.apply(); //apply aggiorna le prefs in bg
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public void addString(String prefName, String newValue ){

        JSONObject jsonObject=new JSONObject();
        try {

            if (callerSharedPrefs.contains(prefName + "_old")) {

                String oldValue=callerSharedPrefs.getString(prefName+"_old","");

                if(!oldValue.equals(newValue)){

                    jsonObject.put("old", oldValue);
                    jsonObject.put("new",newValue);
                    prefsOldNew.put(prefName,jsonObject.toString());

                    //update shared preferences dell'app chiamante
                    SharedPreferences.Editor editor=callerSharedPrefs.edit();
                    editor.putString(prefName+"_old",newValue);
                    editor.apply(); //apply aggiorna le prefs in bg
                }

            } else { //se è la prima volta che l'utente tocca quella pref

                jsonObject.put("old", null);
                jsonObject.put("new",newValue);
                prefsOldNew.put(prefName,jsonObject.toString());

                //update shared preferences dell'app chiamante
                SharedPreferences.Editor editor=callerSharedPrefs.edit();
                editor.putString(prefName+"_old",newValue);
                editor.apply(); //apply aggiorna le prefs in bg
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
    }

    public JSONObject getUserSettingsChangesInJSONFormat(){

        return new JSONObject(prefsOldNew);
    }

    public void clear(){ //reset di tutti i cambiamenti delle pref

        prefsOldNew.clear();
    }

}
